package spinfo.textadventure;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import spinfo.textadventure.data.Place;
import spinfo.textadventure.data.Player;
import spinfo.textadventure.data.World;
import spinfo.textadventure.io.IO;
import spinfo.textadventure.utils.Readers;

public class MyIO implements IO {

	private Readers reader = new Readers();

	@Override
	public List<Place> loadPlaces() throws InvalidGameException {
		List<Place> places = new ArrayList<Place>();
		try {
			List<String> fileContentList = reader.fileToStringList("games/adventure/places.config");

			String name = "";
			String action = "";
			List<String> addConditions = new ArrayList<String>();
			List<String> inConditions = new ArrayList<String>();
			List<String> removeConditions = new ArrayList<String>();
			String game = "";

			for (int i = 0; i < fileContentList.size(); i++) {
				String line = fileContentList.get(i);
				if (line.startsWith("name=")) {
					action = "";
					addConditions = new ArrayList<String>();
					inConditions = new ArrayList<String>();
					removeConditions = new ArrayList<String>();
					name = line.replaceFirst("name=", "");
				}
				if (line.startsWith("add_conditions=")) {
					String[] conditionsarray = line.replaceFirst("add_conditions=", "").split(",");
					// addConditions = Arrays.asList(conditionsarray);
					for (String entry : conditionsarray) {
						addConditions.add(entry);
					}
				}
				if (line.startsWith("in_conditions=")) {
					String[] inConditionsarray = line.replaceFirst("in_conditions=", "").split(",");
					// addConditions = Arrays.asList(conditionsarray);
					for (String entry : inConditionsarray) {
						inConditions.add(entry);
					}
				}
				if (line.startsWith("remove_conditions=")) {
					String[] removeConditionsarray = line.replaceFirst("remove_conditions=", "").split(",");
					// addConditions = Arrays.asList(conditionsarray);
					for (String entry : removeConditionsarray) {
						removeConditions.add(entry);
					}
				}
				if (line.isEmpty() || fileContentList.size() - 1 == i) {
					Place p = new MyPlace();
					p.setName(name);
					p.setAction(action);
					p.setAddConditions(addConditions);
					p.setInConditions(inConditions);
					p.setRemoveConditions(removeConditions);
					places.add(p);
				}
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		for (Place p : places) {
			System.out.println(p.getName());
			System.out.println(p.getInConditions());
		}
		return places;
	}

	@Override
	public World loadWorld(List<Place> loadedPlaces) throws InvalidGameException, FileNotFoundException {
		World world;
		List<String> worldConfig = reader.fileToStringList("games/adventure/world.config");
		for(String worldPlaces : worldConfig){
			for(String singleWorldPlace : worldPlaces.split("\\|")){
//				TODO: singleWorldPlace.trim() abgleichen mit Places-Liste
//				Übergebn mit Setter aus MyWorld...
//				printmap, getPosition...
			}
		}
		
		return null;
	}

	@Override
	public void saveGame(Player player) throws IOException {
	}

	@Override
	public Player loadGame(boolean loadSaveGame) throws IOException {

		return null;
	}

	@Override
	public void setGameDirectory(File gameDirectory) {
	}

}
